﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using MindFusion.Diagramming;
using System.Xml;
using System.Drawing;

namespace IconNodes
{
	public class CustomDiagramLink : DiagramLink
	{
		private string _sqlCondition;
		public string SQLCondition
		{
			get
			{
				return _sqlCondition;
			}
			set
			{
				_sqlCondition = value;
			}
		}

		private string _bindableText;
		public string BindableText
		{
			get
			{
				return _bindableText;
			}
			set
			{
				Text = _bindableText = value;
			}
		}

		public CustomDiagramLink(Diagram parent)
			: base(parent)
		{
			Init();
		}

		public CustomDiagramLink(Diagram parent, DiagramNode origin, Point point)
			: base(parent, origin, point)
		{
			Init();
		}

		public CustomDiagramLink(Diagram parent, DiagramNode origin, DiagramNode destination)
			: base(parent, origin, destination)
		{
			Init();
		}

		private void Init()
		{
			SetStyle();
		}

		private void SetStyle()
		{
			MindFusion.Drawing.Brush defaultBrush = new MindFusion.Drawing.SolidBrush(Color.Black);

			Brush = defaultBrush; //arrow head background
			Pen = new MindFusion.Drawing.Pen(Color.Pink, 5); //arrow line
			BaseShape = Shapes.Alternative;
			HeadShape = Shapes.Alternative;
			HeadPen.Brush = defaultBrush; //arrow head border
			TextBrush = defaultBrush;
		}

		protected override void SaveToXml(XmlElement xmlElement, XmlPersistContext context)
		{
			base.SaveToXml(xmlElement, context);

			context.WriteString(SQLCondition, "SQLCondition", xmlElement);
			//context.WriteObjectCollection(Actions, "Actions", xmlElement);
		}

		protected override void LoadFromXml(XmlElement xmlElement, XmlPersistContext context)
		{
			base.LoadFromXml(xmlElement, context);
			SQLCondition = context.ReadString("SQLCondition", xmlElement);

			//Actions = context.ReadObjectCollection("Actions", xmlElement);

			SetStyle();
		}
	}
 


}